/*
 * $Id: icicle.c,v 1.3 2001/01/13 17:47:45 nachtfalke Exp $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <sys/stat.h>
#include <unistd.h>

#include <shout/shout.h>

#include <glib.h>

#include "mp3info.h"
#include "do_list.h"

int reencode = 0;
int main( int argc, char *argv[] )
{
        shout_conn_t conn;
        gchar * foo;
	gchar error[256];
	guint i,c;
	GSList *list = NULL;
	extern char *optarg;
	extern int optind, opterr, optopt;
	int loop=0;
	struct hostent *host;
	struct in_addr *addrptr;
		

	if( argc > 1)
	{
		shout_init_connection(&conn);
		conn.ip = "127.0.0.1";
		conn.port = 8000;
		conn.password = "letmein";
		conn.mount = "default";
		conn.name = "Default Stream";
		while(1)
		{
			c = getopt(argc, argv, "h:P:p:m:n:?lr:");
			if(c==-1)
				break;
			switch (c)
			{
				case '?':
					foo = strrchr(argv[0],'/');
					printf("%s Version %s\n",PACKAGE,VERSION);
					printf("Usage: %s [options] <files>\n",++foo);
					printf("-? Show usage info\n");
					printf("-h server name\n");
					printf("-p server port\n");
					printf("-P server password\n");
					printf("-m mount point\n");
					printf("-n stream name\n");
					printf("-l loop stream\n");
					printf("-r <br> reencode to bitrate\n");
					
					return(0);
				case 'h':
					host = gethostbyname(optarg);
					if(host!=NULL)
					{
						addrptr=(struct in_addr *) host->h_addr;
					}
					else
					{
						printf("No such host.\n");
						return(-1);
					}
					conn.ip=(char *)malloc(strlen(inet_ntoa(*addrptr))*sizeof(char));
					conn.ip=strcpy(conn.ip,inet_ntoa(*addrptr));
					break;
				case 'P':
					conn.password=(char *)malloc(strlen(optarg)*sizeof(char));
					conn.password=strcpy(conn.password,optarg);
					break;
				case 'p':
					conn.port=atoi(optarg);
					break;
				case 'r':
					conn.bitrate=atoi(optarg);
					reencode=conn.bitrate;
					break;
				case 'm':
					conn.mount=(char *)malloc(strlen(optarg)*sizeof(char));
					conn.mount=strcpy(conn.mount,optarg);
					break;
				case 'n':
					conn.name=(char *)malloc(strlen(optarg)*sizeof(char));
					conn.name=strcpy(conn.name,optarg);
					break;
				case 'l':
					loop=1;
					break;

			}
		}
		if (shout_connect(&conn))
		{
			printf("%s Version %s\n",PACKAGE,VERSION);
			printf("-=[ %s ]=- mounted on %s\n",conn.name,conn.mount);
			printf("Connected to server %s...\n",conn.ip);
			printf("Looping:  %i...\n",loop);

			for( i=optind ; i<argc ; i++ )
			{
				printf("%s\n",argv[i]);
				list = g_slist_append(list,argv[i]);
			}
			while(1)
			{
				g_slist_foreach(list,(GFunc)do_list,(gpointer *)&conn);
				if(loop==0)
					break;
			}
		} else {
			shout_strerror(&conn,conn.error,error,255);
			printf("Couldn't connect.\n%s\n",error);
		}
		return(-1);
	}
	else
	{
		foo = strrchr(argv[0],'/');
		printf("%s Version %s\n",PACKAGE,VERSION);
		printf("Usage: %s [options] <files>\n",++foo);
		printf("-? Show usage info\n");
		printf("-h server ip\n");
		printf("-p server port\n");
		printf("-P server password\n");
		printf("-m mount point\n");
		printf("-n stream name\n");
		printf("-l loop stream\n");
		return(0);
	}

	shout_disconnect(&conn);
	free(conn.ip);
	free(conn.password);
	free(conn.mount);
	free(conn.name);
	g_slist_free(list);

	return 0;
}
