#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lame.h>

#include "stream_file_reencode.h"

int stream_file_reencode( shout_conn_t connection, char *filename, char *metadata, int br )
{
	lame_global_flags gf;
	short int buf[2][1152];
	int iread,imp3,foo;
	int status=0;
	long read,ret;
	char mp3buffer[LAME_MAXMP3BUFFER];

	
	lame_init(&gf);
	
	gf.brate = br;
	strcpy(gf.inPath,filename);
	lame_init_params(&gf);

	gf.input_format=filename_to_type(gf.inPath);
//	gf.input_format=sf_mp3;
	lame_init_infile(&gf);
	lame_print_config(&gf);
	ret = shout_update_metadata( &connection, metadata);
	if (ret != 1)
	{
		printf("Updating metadata on server failed.\n");                      
		return(-1);
	}
	while((iread=lame_readframe(&gf,buf)))
	{
//		printf(".");
		fflush(stdout);
		imp3 = lame_encode_buffer(&gf,buf[0],buf[1],iread, mp3buffer,(int)sizeof(mp3buffer));
		if(imp3 > 0)
		{
			ret = shout_update_metadata( &connection, metadata);
			if (ret != 1)
			{
				printf("Updating metadata on server failed.\n");                      
				status=-1;
				break;
			}
			ret = shout_send_data(&connection, mp3buffer, (unsigned long)imp3);
			if (!ret)
			{
				status = -1;
				break;
			}
			shout_sleep(&connection);
		}
	}
	imp3=lame_encode_finish(&gf, mp3buffer, (int)sizeof(mp3buffer));
	if(imp3 > 0)
	{
		ret = shout_send_data(&connection, mp3buffer, (unsigned long)imp3);
		if (!ret)
		{
			status = -1;
			return(status);
		}
	}
	lame_close_infile(&gf);
	return(status);
}

int filename_to_type ( const char* FileName )
{
	size_t len = strlen (FileName);

	if ( len < 4 ) return sf_unknown;

	FileName += len-4;
	if ( 0 == strcasecmp ( FileName, ".mpg" ) ) return sf_mp1;
	if ( 0 == strcasecmp ( FileName, ".mp1" ) ) return sf_mp1;
	if ( 0 == strcasecmp ( FileName, ".mp2" ) ) return sf_mp2;
	if ( 0 == strcasecmp ( FileName, ".mp3" ) ) return sf_mp3;
	if ( 0 == strcasecmp ( FileName, ".ogg" ) ) return sf_ogg;
	if ( 0 == strcasecmp ( FileName, ".wav" ) ) return sf_wave;
	if ( 0 == strcasecmp ( FileName, ".aif" ) ) return sf_aiff;
	if ( 0 == strcasecmp ( FileName, ".raw" ) ) return sf_raw;
	return sf_unknown;
}

